﻿Imports System.IO
Module Lecture
    'Lecture et écriture du fichier de données
    Dim title As String = "Dallage : module de lecture/écriture"
    Dim style As MsgBoxStyle = MsgBoxStyle.Critical Or MsgBoxStyle.OKOnly

#Region " Code de lecture du fichier de données "

    Public Sub Lecture_fichier(ByVal Filename As String, ByRef Chantier As String, ByRef Redacteur As String, ByRef i_result As Integer, ByRef i_data As Integer, ByRef msgData As String, ByRef msgResult As String, _
                                     ByRef Retrait_Force As Boolean, ByRef BAEL91 As Boolean, ByRef dT_abri As Double, ByRef Var_T As Boolean, ByRef Grad_T As Boolean, ByRef Maille As Double, _
                                       ByRef Arret_Coulage As Boolean, ByRef Joint_Retrait As Integer, ByRef ϕ_σr As Double, _
                                       ByRef Type_Dallage As Integer, ByRef Limit_Fissure As Boolean, ByRef Gradient As Boolean, ByRef Tsurf As Double, ByRef Tsouf As Double, _
                               ByRef Intemperie As Boolean, ByRef LX As Double, ByRef LY As Double, ByRef H_Dal As Double, ByRef epChap As Double, ByRef Arma As Boolean, _
                                ByRef Joint_DTU As Boolean, ByRef Esp_Joint As Double, ByRef Bordure_conjugue As Boolean, _
                                 ByRef Bordfixe As Boolean, ByRef Conjugue_1_Angle As Boolean, ByRef Conjugue_2_Angle As Boolean, ByRef Conjugue_3_Angle As Boolean, _
                               ByRef Dens As Double, ByRef µ As Double, ByRef Total_Sol As Integer, ByRef H_sol() As Double, _
                               ByRef Es() As Double, ByRef Substratum As Boolean, ByRef Fc As Integer, ByRef Choix_Eyb As Integer, _
                             ByRef vgb As Double, ByRef cg As Double, ByRef enr As Double, ByRef Fe As Integer, ByRef Eys As Integer, ByRef vgs As Double, _
                             ByRef Type_Acier As Integer, ByRef NbLit As Integer, ByRef Total_Cr As Integer, ByRef Total_Ci As Integer, ByRef Total_Cm As Integer, _
                                ByRef Total_Comb_ELU As Integer, ByRef Total_Comb_ELS As Integer, _
                              ByRef Cr() As Double, ByRef X1Cr() As Double, ByRef Y1Cr() As Double, ByRef X2Cr() As Double, ByRef Y2Cr() As Double, ByRef Ci() As Double, _
                                     ByRef XCi() As Double, ByRef YCi() As Double, ByRef LPlatX() As Double, ByRef LPlatYY() As Double, ByRef CmAv() As Double, ByRef CmAr() As Double, _
                                     ByRef Pond(,,,) As Double, ByRef Ct() As Double, ByRef D_essieu() As Double, ByRef D_Roue_Av() As Double, ByRef D_Roue_Ar() As Double, _
                                     ByRef xv() As Double, ByRef xr() As Double, ByRef duree(,) As Integer, ByRef Donnee_OK As Boolean)
        ' The StreamReader must be defined outside of the Try-Catch block
        '   in order to reference it in the Finally block.  
        Dim myStreamReader As StreamReader
        Dim i, j As Integer
        Dim toto, msg, titi(20) As String
        Dim Version As Double
        Try
            Donnee_OK = True
            myStreamReader = File.OpenText(Filename)
            toto = myStreamReader.ReadLine : Call Lecture(toto, titi)
            If titi(1) <> "Dallage" Then
                msg = "Il manque l'entête Dallage dans votre fichier." & vbCrLf & "Votre fichier n'est pas compatible avec le programme"
                MsgBox(msg, style, title)
                Donnee_OK = False : Exit Sub
            ElseIf titi(1) = "dallage" Then
                If IsNumeric(titi(2)) = False Then Call Verification_point(titi(2))
                Version = CDbl(titi(2))
                If Version <> 1 Then
                    msg = "La version de votre fichier n'est pas compatible avec le programme"
                    MsgBox(msg, style, title)
                    Donnee_OK = False : Exit Sub
                End If
            End If
            toto = myStreamReader.ReadLine : Call Lecture(toto, titi)
            nomAffaire = CStr(titi(1))
            toto = myStreamReader.ReadLine 'ligne de commentaire "sauvegarde de la configuration de l'affaire"
            toto = myStreamReader.ReadLine : Call LectureGen(toto, titi) 'ligne suivante
            Redacteur = CStr(titi(1))
            toto = myStreamReader.ReadLine : Call LectureGen(toto, titi) 'ligne suivante
            Chantier = CStr(titi(1))
            toto = myStreamReader.ReadLine  'ligne suivante
            msgResult = toto
            toto = myStreamReader.ReadLine   'ligne suivante
            msgData = toto
            toto = myStreamReader.ReadLine : Call LectureGen(toto, titi) 'ligne suivante
            i_result = CInt(titi(1)) : i_data = CInt(titi(2))
            toto = myStreamReader.ReadLine 'ligne de commentaire
            toto = myStreamReader.ReadLine : Call LectureGen(toto, titi) 'ligne suivante
            dT_abri = CDbl(titi(1)) : Var_T = CBool(titi(2)) : Grad_T = CBool(titi(3)) : ϕ_σr = CDbl(titi(4)) : Retrait_Force = CBool(titi(5))
            toto = myStreamReader.ReadLine 'ligne de commentaire
            toto = myStreamReader.ReadLine : Call LectureGen(toto, titi) 'ligne suivante
            Arret_Coulage = CBool(titi(1)) : Joint_Retrait = CInt(titi(2))
            toto = myStreamReader.ReadLine 'ligne de commentaire
            toto = myStreamReader.ReadLine : Call LectureGen(toto, titi) 'ligne suivante
            BAEL91 = CBool(titi(1)) : Maille = CDbl(titi(2))
            toto = myStreamReader.ReadLine 'acier - Beton
            toto = myStreamReader.ReadLine : Call Lecture(toto, titi) 'ligne suivante
            Fe = CInt(titi(1)) : vgs = CDbl(titi(2)) : Eys = CInt(titi(3))
            toto = myStreamReader.ReadLine : Call Lecture(toto, titi) 'ligne suivante
            Type_Acier = CInt(titi(1)) : NbLit = CInt(titi(2)) : espmin = CDbl(titi(3)) : espMax = CDbl(titi(4))
            toto = myStreamReader.ReadLine : Call Lecture(toto, titi) 'ligne suivante
            Fc = CInt(titi(1)) : vgb = CDbl(titi(2)) : enr = CDbl(titi(3)) : cg = CDbl(titi(4))
            toto = myStreamReader.ReadLine : Call Lecture(toto, titi) 'ligne suivante
            Choix_Eyb = CInt(titi(1)) : Eybv = CDbl(titi(2)) : Eybi = CDbl(titi(3))
            toto = myStreamReader.ReadLine 'Geometrie
            toto = myStreamReader.ReadLine : Call Lecture(toto, titi) 'ligne suivante
            H_Dal = CDbl(titi(1)) : LX = CDbl(titi(2)) : LY = CDbl(titi(3)) : epChap = CDbl(titi(4))
            toto = myStreamReader.ReadLine : Call Lecture(toto, titi) 'ligne suivante
            Bordure_conjugue = CBool(titi(1)) : Tsurf = CDbl(titi(2)) : Tsouf = CDbl(titi(3)) : Dens = CDbl(titi(4)) : Conjugue_1_Angle = CBool(titi(5)) : Conjugue_2_Angle = CBool(titi(6)) : Conjugue_3_Angle = CBool(titi(7))
            toto = myStreamReader.ReadLine : Call Lecture(toto, titi) 'ligne suivante
            Arma = CBool(titi(1)) : Intemperie = CBool(titi(2)) : Type_Dallage = CInt(titi(3)) : µ = CDbl(titi(4)) : Bordfixe = CBool(titi(5)) : Joint_DTU = CBool(titi(6)) : Esp_Joint = CDbl(titi(7))
            toto = myStreamReader.ReadLine 'Sols
            toto = myStreamReader.ReadLine : Call Lecture(toto, titi) 'ligne suivante
            Total_Sol = CInt(titi(1)) : Substratum = CBool(titi(2))
            For i = 1 To Total_Sol
                toto = myStreamReader.ReadLine : Call Lecture(toto, titi) 'ligne suivante
                H_sol(i) = CDbl(titi(1)) : Es(i) = CDbl(titi(2))
            Next i
            toto = myStreamReader.ReadLine 'charges
            toto = myStreamReader.ReadLine : Call Lecture(toto, titi) 'ligne suivante
            Total_Cr = CInt(titi(1))
            For i = 1 To Total_Cr
                toto = myStreamReader.ReadLine : Call Lecture(toto, titi) 'ligne suivante
                Cr(i) = CDbl(titi(1)) : X1Cr(i) = CDbl(titi(2)) : Y1Cr(i) = CDbl(titi(3)) : X2Cr(i) = CDbl(titi(4)) : Y2Cr(i) = CDbl(titi(5))
                toto = myStreamReader.ReadLine : Call Lecture(toto, titi) 'ligne suivante
                duree(i, 1) = CInt(titi(1))
            Next i
            toto = myStreamReader.ReadLine : Call Lecture(toto, titi) 'ligne suivante
            Total_Ci = CInt(titi(1))
            For i = 1 To Total_Ci
                toto = myStreamReader.ReadLine : Call Lecture(toto, titi) 'ligne suivante
                Ci(i) = CDbl(titi(1)) : XCi(i) = CDbl(titi(2)) : YCi(i) = CDbl(titi(3)) : LPlatX(i) = CDbl(titi(4)) : LPlatYY(i) = CDbl(titi(5))
                toto = myStreamReader.ReadLine : Call Lecture(toto, titi) 'ligne suivante
                duree(i, 2) = CInt(titi(1))
            Next i
            toto = myStreamReader.ReadLine : Call Lecture(toto, titi) 'ligne suivante
            Total_Cm = CInt(titi(1))
            For i = 1 To Total_Cm
                toto = myStreamReader.ReadLine : Call Lecture(toto, titi) 'ligne suivante
                CmAv(i) = CDbl(titi(1)) : CmAr(i) = CDbl(titi(2)) : D_essieu(i) = CDbl(titi(3)) : D_Roue_Av(i) = CDbl(titi(4)) : D_Roue_Ar(i) = CDbl(titi(5)) : xv(i) = CDbl(titi(6)) : xr(i) = CDbl(titi(7)) : Ct(i) = CDbl(titi(8))
            Next i
            toto = myStreamReader.ReadLine : Call Lecture(toto, titi) 'ligne suivante
            Total_Comb_ELU = CInt(titi(1))
            For i = 1 To Total_Comb_ELU
                For j = 1 To Total_Cr
                    toto = myStreamReader.ReadLine : Call Lecture(toto, titi) 'ligne suivante
                    Pond(1, i, j, 1) = CDbl(titi(1))
                Next
                For j = 1 To Total_Ci
                    toto = myStreamReader.ReadLine : Call Lecture(toto, titi) 'ligne suivante
                    Pond(1, i, j, 2) = CDbl(titi(1))
                Next
                For j = 1 To Total_Cm
                    toto = myStreamReader.ReadLine : Call Lecture(toto, titi) 'ligne suivante
                    Pond(1, i, j, 3) = CDbl(titi(1))
                Next
            Next
            toto = myStreamReader.ReadLine : Call Lecture(toto, titi) 'ligne suivante
            Total_Comb_ELS = CInt(titi(1))
            For i = 1 To Total_Comb_ELS
                For j = 1 To Total_Cr
                    toto = myStreamReader.ReadLine : Call Lecture(toto, titi) 'ligne suivante
                    Pond(2, i, j, 1) = CDbl(titi(1))
                Next
                For j = 1 To Total_Ci
                    toto = myStreamReader.ReadLine : Call Lecture(toto, titi) 'ligne suivante
                    Pond(2, i, j, 2) = CDbl(titi(1))
                Next
                For j = 1 To Total_Cm
                    toto = myStreamReader.ReadLine : Call Lecture(toto, titi) 'ligne suivante
                    Pond(2, i, j, 3) = CDbl(titi(1))
                Next
            Next

        Catch exc As Exception
            ' Show the exception to the user.
            MsgBox("Le fichier ne peut être ouvert ou lu." + vbCrLf + _
                "SVP, verifiez que le nom du fichier est correct, " + _
                "et que vouz avez la permission de lire ou d'écrire " + _
                "dans le répertoire indiqué." + vbCrLf + vbCrLf + "Erreur: " + exc.Message, MsgBoxStyle.Critical, title)
            Donnee_OK = False
        Finally
            ' Close the object if it has been created.
            If Not myStreamReader Is Nothing Then
                myStreamReader.Close()
            End If
        End Try
    End Sub

    Private Sub Lecture(ByVal toto As String, ByRef titi() As String)
        Dim blanc(15), i, j, position As Integer
        Dim tutu As String
        toto = Trim(toto) 'supprime les espaces en debut et fin de chaine
        titi(1) = Microsoft.VisualBasic.Left(toto, 1)
        i = Len(toto)     'indique la longueur totale de la chaine
        'recherche de blanc dans la chaine
        j = 0 : blanc(1) = 1 : titi(1) = toto
        Do
            j = j + 1
            position = InStr(1, titi(j), " ") 'détermine le nombre et la position des blanc 
            blanc(j) = position                      'dans la chaine
            tutu = titi(j)
            If position <> 0 Then
                titi(j) = Microsoft.VisualBasic.Left(tutu, position - 1)
                titi(j + 1) = Microsoft.VisualBasic.Right(tutu, i - position)
                titi(j + 1) = Trim(titi(j + 1))
                i = Len(titi(j + 1))
            End If
        Loop While blanc(j) <> 0
    End Sub
    Private Sub Verification_point(ByRef tata As String)
        Dim position As Integer
        position = InStr(1, tata, ".")
        If position <> 0 Then
            Mid(tata, position) = ","
        End If
    End Sub
#End Region

#Region " Code d'écriture du fichier de données "
    Public Sub Ecriture_Fichier(ByVal FileName As String, ByVal Chantier As String, ByVal Redacteur As String, ByVal i_result As Integer, ByVal i_data As Integer, _
                                ByVal msgData As String, ByVal msgResult As String, ByVal Retrait_Force As Boolean, ByVal BAEL91 As Boolean, ByVal dT_abri As Double, ByVal Var_T As Boolean, _
                                  ByVal Grad_T As Boolean, ByVal Maille As Double, ByVal Arret_Coulage As Boolean, ByVal Joint_Retrait As Integer, ByVal ϕ_σr As Double, _
                               ByVal Type_Dallage As Integer, ByVal Limit_Fissure As Boolean, ByVal Gradient As Boolean, ByVal Tsurf As Double, ByVal Tsouf As Double, _
                                ByVal Intemperie As Boolean, ByVal LX As Double, ByVal LY As Double, ByVal H_Dal As Double, ByVal epChap As Double, ByVal Arma As Boolean, _
                               ByVal Joint_DTU As Boolean, ByVal Esp_Joint As Double, ByVal Bordure_conjugue As Boolean, ByVal Bordfixe As Boolean, ByVal Conjugue_1_Angle As Boolean, _
                               ByVal Conjugue_2_Angle As Boolean, ByVal Conjugue_3_Angle As Boolean, _
                                ByVal Dens As Double, ByVal µ As Double, ByVal Total_Sol As Integer, ByVal H_sol() As Double, _
                               ByVal Es() As Double, ByVal Substratum As Boolean, ByVal Fc As Integer, _
                        ByVal Choix_Eyb As Integer, ByVal vgb As Double, ByVal cg As Double, ByVal enr As Double, ByVal Fe As Integer, ByVal Eys As Integer, ByVal vgs As Double, _
                        ByVal Type_Acier As Integer, ByVal NbLit As Integer, ByVal Total_Cr As Integer, ByVal Total_Ci As Integer, ByVal Total_Cm As Integer, ByVal Total_Comb_ELU As Integer, _
                               ByVal Total_Comb_ELS As Integer, _
                                ByVal Cr() As Double, ByVal X1Cr() As Double, ByVal Y1Cr() As Double, ByVal X2Cr() As Double, ByVal Y2Cr() As Double, ByVal Ci() As Double, _
                                     ByVal XCi() As Double, ByVal YCi() As Double, ByVal LPlatX() As Double, ByVal LPlatYY() As Double, ByVal CmAv() As Double, ByVal CmAr() As Double, _
                                     ByVal Pond(,,,) As Double, ByVal Ct() As Double, ByVal D_essieu() As Double, ByVal D_Roue_Av() As Double, ByVal D_Roue_Ar() As Double, _
                                     ByVal xv() As Double, ByVal xr() As Double, ByVal duree(,) As Integer)
        ' The StreamWriter must be defined outside of the Try-Catch block
        '   in order to reference it in the Finally block.
        Dim myStreamWriter As StreamWriter
        Dim i, j As Integer

        Try
            ' Create a StreamWriter using a Shared (static) File class.
            myStreamWriter = File.CreateText(FileName)

            myStreamWriter.WriteLine("Dallage 1.0")
            myStreamWriter.WriteLine(nomAffaire)
            'sauvegarde de la configuration de l'affaire
            myStreamWriter.WriteLine("sauvegarde de la configuration de l'affaire")
            myStreamWriter.WriteLine(Redacteur)
            myStreamWriter.WriteLine(Chantier)
            'répertoire
            myStreamWriter.WriteLine(msgResult)
            myStreamWriter.WriteLine(msgData)
            myStreamWriter.WriteLine(i_result & " " & i_data)
            myStreamWriter.WriteLine("formulaire configuration Onglets option calcul")
            myStreamWriter.WriteLine(dT_abri & " " & Var_T & " " & Grad_T & " " & ϕ_σr & " " & Retrait_Force)
            myStreamWriter.WriteLine("formulaire configuration Onglets option construction")
            myStreamWriter.WriteLine(Arret_Coulage & " " & Joint_Retrait)
            myStreamWriter.WriteLine("formulaire configuration Onglets option modelisation")
            myStreamWriter.WriteLine(BAEL91 & " " & Maille)

            'acier - Beton
            myStreamWriter.WriteLine("Hypothèse")
            myStreamWriter.WriteLine(Fe & " " & vgs & " " & Eys) '& " " & angle1 & " " & angle2 & " " & angle3)
            myStreamWriter.WriteLine(Type_Acier & " " & NbLit & " " & espmin & " " & espMax)
            myStreamWriter.WriteLine(Fc & " " & vgb & " " & enr & " " & cg)
            myStreamWriter.WriteLine(Choix_Eyb & " " & Eybv & " " & Eybi)
            'Geometrie
            myStreamWriter.WriteLine("Geometrie")
            myStreamWriter.WriteLine(H_Dal & " " & LX & " " & LY & " " & epChap)
            myStreamWriter.WriteLine(Bordure_conjugue & " " & Tsurf & " " & Tsouf & " " & Dens & " " & Conjugue_1_Angle & " " & Conjugue_2_Angle & " " & Conjugue_3_Angle)
            myStreamWriter.WriteLine(Arma & " " & Intemperie & " " & Type_Dallage & " " & µ & " " & Bordfixe & " " & Joint_DTU & " " & Esp_Joint)
            'Sols
            myStreamWriter.WriteLine("sols")
            myStreamWriter.WriteLine(Total_Sol & " " & Substratum)
            For i = 1 To Total_Sol
                myStreamWriter.WriteLine(H_sol(i) & " " & Es(i))
            Next i
            'charges
            myStreamWriter.WriteLine("Charges")
            myStreamWriter.WriteLine(Total_Cr)
            For i = 1 To Total_Cr
                myStreamWriter.WriteLine(Cr(i) & " " & X1Cr(i) & " " & Y1Cr(i) & " " & X2Cr(i) & " " & Y2Cr(i))
                myStreamWriter.WriteLine(duree(i, 1))
            Next i
            myStreamWriter.WriteLine(Total_Ci)
            For i = 1 To Total_Ci
                myStreamWriter.WriteLine(Ci(i) & " " & XCi(i) & " " & YCi(i) & " " & LPlatX(i) & " " & LPlatYY(i))
                myStreamWriter.WriteLine(duree(i, 2))
            Next i
            myStreamWriter.WriteLine(Total_Cm)
            For i = 1 To Total_Cm
                myStreamWriter.WriteLine(CmAv(i) & " " & CmAr(i) & " " & D_essieu(i) & " " & D_Roue_Av(i) & " " & D_Roue_Ar(i) & " " & xv(i) & " " & xr(i) & " " & Ct(i))
            Next i
            myStreamWriter.WriteLine(Total_Comb_ELU)
            For i = 1 To Total_Comb_ELU
                For j = 1 To Total_Cr
                    myStreamWriter.WriteLine(Pond(1, i, j, 1))
                Next
                For j = 1 To Total_Ci
                    myStreamWriter.WriteLine(Pond(1, i, j, 2))
                Next
                For j = 1 To Total_Cm
                    myStreamWriter.WriteLine(Pond(1, i, j, 3))
                Next
            Next
            myStreamWriter.WriteLine(Total_Comb_ELS)
            For i = 1 To Total_Comb_ELS
                For j = 1 To Total_Cr
                    myStreamWriter.WriteLine(Pond(2, i, j, 1))
                Next
                For j = 1 To Total_Ci
                    myStreamWriter.WriteLine(Pond(2, i, j, 2))
                Next
                For j = 1 To Total_Cm
                    myStreamWriter.WriteLine(Pond(2, i, j, 3))
                Next
            Next



            ' Flush the stream to ensure everything is flushed
            myStreamWriter.Flush()
        Catch exc As Exception
            MsgBox("File could not be opened or written to." + vbCrLf + _
                "Please verify that the filename is correct, " + _
                "and that you have read permissions for the desired " + _
                "directory." + vbCrLf + vbCrLf + "Exception: " + exc.Message)
        Finally
            ' Close the object if it has been created.
            If Not myStreamWriter Is Nothing Then
                myStreamWriter.Close()
            End If
        End Try
    End Sub
#End Region

End Module
