Public Class frmGeom

    Private Sub frmGeom_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Call affichage_Initial()
    End Sub
#Region "Gestion des Textbox"
 
    Private Sub TextLong_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextLX.KeyPress
        Call Gestion_Keypress(e, TextLX, True)
    End Sub
    Private Sub TextLarg_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextLY.KeyPress
        Call Gestion_Keypress(e, TextLY, True)
    End Sub
    Private Sub TextEp_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextEp.KeyPress
        Call Gestion_Keypress(e, TextEp, True)
    End Sub
    Private Sub TextEpchap_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextepChap.KeyPress
        Call Gestion_Keypress(e, TextepChap, True)
    End Sub
    Private Sub TextDensBA_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextDensBA.KeyPress
        Call Gestion_Keypress(e, TextDensBA, True)
    End Sub
    Private Sub TextDensBnA_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextDensBnA.KeyPress
        Call Gestion_Keypress(e, TextDensBnA, True)
    End Sub
#End Region
    Private Sub Affichage_Initial()

        TextLX.Text = frmDal.LX.ToString("##0.00")
        TextLY.Text = frmDal.LY.ToString("##0.00")
        TextEp.Text = (frmDal.H_Dal * 100).ToString("##0")
        TextepChap.Text = (frmDal.epChap * 100).ToString("##0")

        'joints
        If frmDal.Joint_DTU = True Then
            Rbtn_Avec_Joint.Checked = True
            TxtEsp_Joint.Text = frmDal.Esp_Joint.ToString("#0.00")
        Else
            Rbtn_Sans_Joint.Checked = True
        End If
        'dallage arm
        If frmDal.Arma = True Then
            RbtnArme.Checked = True : TextDensBA.Text = frmDal.Dens.ToString("#,##0")
            TextDensBnA.Text = "0" : TextDensBnA.Enabled = False
        Else
            RbtnNonArme.Checked = True : TextDensBnA.Text = frmDal.Dens.ToString("#,##0")
            TextDensBA.Text = "0" : TextDensBA.Enabled = False
        End If
        'desolidarisation des lments de structure
        If frmDal.Structure_Solidaire = True Then
            RbtnSolidarise.Checked = True
        Else
            Rbtn_Desolidarise.Checked = True
        End If
        If frmDal.Bordfixe = True Then
            ChkbBordureLiaison.Checked = True
        Else
            ChkbBordureLiaison.Checked = False
        End If
        'couche de glissement
        If frmDal. = 0.5 Then RbtnSable.Checked = True Else RbtnLisse.Checked = True
        'Bordure
        If frmDal.Bordure_conjugue = True Then ChkbBordureConjugue.Checked = True Else ChkbBordureLiaison.Checked = False
        'Angle
        If frmDal.Conjugue_1_Angle = True Then ChkbAngleConjugue1.Checked = True Else ChkbAngleConjugue1.Checked = False
        If frmDal.Conjugue_2_Angle = True Then ChkbAngleConjugue2.Checked = True Else ChkbAngleConjugue2.Checked = False
        If frmDal.Conjugue_3_Angle = True Then ChkbAngleConjugue3.Checked = True Else ChkbAngleConjugue3.Checked = False
    End Sub
    Private Sub Lecture(ByRef Verif As Boolean)
        If gestionderreur(TextLX) = True Then frmDal.LX = CDbl(TextLX.Text) Else Verif = False
        If gestionderreur(TextLY) = True Then frmDal.LY = CDbl(TextLY.Text) Else Verif = False
        If gestionderreur(TextEp) = True Then frmDal.H_Dal = (CDbl(TextEp.Text) / 100) Else Verif = False
        If gestionderreur(TextepChap) = True Then frmDal.epChap = (CDbl(TextepChap.Text) / 100) Else Verif = False
        'joints
        If Rbtn_Sans_Joint.Checked = True Then
            frmDal.Joint_DTU = False
        ElseIf Rbtn_Avec_Joint.Checked = True Then
            frmDal.Joint_DTU = True
            If gestionderreur(TxtEsp_Joint) = True Then frmDal.Esp_Joint = CDbl(TxtEsp_Joint.Text) Else Verif = False
        Else
            MessageBox.Show("La ralisation de joint sur le dallage n'a pas t prcise.", Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Verif = False
        End If
        'type de dallage
        If RbtnArme.Checked = True Then
            frmDal.Arma = True 'dallage en bton arm
            If gestionderreur(TextDensBA) = True Then frmDal.Dens = CDbl(TextDensBA.Text) Else Verif = False
        ElseIf RbtnNonArme.Checked = True Then
            frmDal.Arma = False 'dallage en bton non arm
            If gestionderreur(TextDensBnA) = True Then frmDal.Dens = CDbl(TextDensBnA.Text) Else Verif = False
        Else
            MessageBox.Show("Le type de dallage n'a pas t prcis.", Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Verif = False
        End If
        'couche de glissement
        If RbtnSable.Checked = True Then
            frmDal. = 0.5
        ElseIf RbtnLisse.Checked = True Then
            frmDal. = 1.5
        Else
            MessageBox.Show("La couche de glissement n'a pas t prcise.", Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Verif = False
        End If
        'dsolidarisation lments de structure
        If RbtnSolidarise.Checked = True Then
            frmDal.Structure_Solidaire = True
        ElseIf Rbtn_Desolidarise.Checked = True Then
            frmDal.Structure_Solidaire = False
        Else
            MessageBox.Show("La dsolidarisation vis  vis des lments de structure n'a pas t prcise.", Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Verif = False
        End If
        If ChkbBordureLiaison.Checked = True Then frmDal.Bordfixe = True Else frmDal.Bordfixe = False
        'Bordure
        If ChkbBordureConjugue.Checked = True Then frmDal.Bordure_conjugue = True Else frmDal.Bordure_conjugue = False
        'Angle
        If ChkbAngleConjugue1.Checked = True Then frmDal.Conjugue_1_Angle = True Else frmDal.Conjugue_1_Angle = False
        If ChkbAngleConjugue2.Checked = True Then frmDal.Conjugue_2_Angle = True Else frmDal.Conjugue_2_Angle = False
        If ChkbAngleConjugue3.Checked = True Then frmDal.Conjugue_3_Angle = True Else frmDal.Conjugue_3_Angle = False

    End Sub
    Private Function gestionderreur(ByVal e As System.Windows.Forms.TextBox) As Boolean
        If e.Text = "" Then
            EP1.SetError(e, "le champ n'a pas t renseign!!")
            gestionderreur = False
        ElseIf Not IsNumeric(CDbl(e.Text)) Then
            EP1.SetError(e, "le champ n'est pas une valeur numrique !!")
            gestionderreur = False
        Else
            EP1.SetError(e, "") ' Clear the error.
            gestionderreur = True
        End If
    End Function
    Private Sub Verification(ByRef Verif As Boolean)
        Dim msg As String

        If frmDal.Type_Dallage = 1 Then
            If frmDal.H_Dal < 0.15 Then
                msg = "Epaisseur nominale du dallage > 15cm"
                MsgBox(msg, MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, Me.Text)
                EP1.SetError(TextEp, msg)
                Verif = False
            End If
        End If
        If frmDal.Type_Dallage = 2 Then
            If frmDal.H_Dal < 0.13 Then
                msg = "Epaisseur nominale du dallage > 13cm"
                MsgBox(msg, MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, Me.Text)
                EP1.SetError(TextEp, msg)
                Verif = False
            End If
        End If
        If frmDal.Type_Dallage = 3 Then
            If frmDal.H_Dal < 0.12 Then
                msg = "Epaisseur nominale du dallage > 12cm"
                MsgBox(msg, MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, Me.Text)
                EP1.SetError(TextEp, msg)
                Verif = False
            End If
        End If
        If frmDal.LX < 2 Then
            msg = "La longueur suivant X du dallage doit tre renseign"
            MsgBox(msg, MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, Me.Text)
            EP1.SetError(TextLX, msg)
            Verif = False
        End If
        If frmDal.LY < 2 Then
            msg = "La longueur suivant Y du dallage doit tre renseign"
            MsgBox(msg, MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, Me.Text)
            EP1.SetError(TextLY, msg)
            Verif = False
        End If
    End Sub
    Private Sub BtnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnOK.Click
        Dim Verif As Boolean = True
        Call Lecture(Verif)
        If Verif = False Then Exit Sub
        Call verification(Verif)
        If Verif = False Then Exit Sub
        frmDal.Affichage_Geometrie = 1
        frmDal.Affichage_general = 1
        Me.Dispose()
        Me.Finalize()
    End Sub

    Private Sub BtnAnnuler_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnAnnuler.Click
        Me.Dispose()
        Me.Finalize()
    End Sub

    Private Sub RbtnArme_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RbtnArme.CheckedChanged
        If RbtnArme.Checked = True Then
            TextDensBA.Enabled = True
            TextDensBnA.Text = "0" : TextDensBnA.Enabled = False
            TextDensBA.Focus()
        End If
    End Sub

    Private Sub RbtnNonArme_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RbtnNonArme.CheckedChanged
        If RbtnNonArme.Checked = True Then
            TextDensBnA.Enabled = True
            TextDensBA.Text = "0" : TextDensBA.Enabled = False
            TextDensBnA.Focus()
        End If
    End Sub



    Private Sub BtnHlpCouche_support_Click(sender As System.Object, e As System.EventArgs) Handles BtnHlpCouche_support.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        FichierAide = 1
        frm1.Show()
    End Sub
    Private Sub BtnHlpAngle_Click(sender As System.Object, e As System.EventArgs) Handles BtnHlpAngle.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        FichierAide = 9
        frm1.Show()
    End Sub
    Private Sub BtnHlpBordureConjugue_Click(sender As System.Object, e As System.EventArgs) Handles BtnHlpBordureConjugue.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        FichierAide = 10
        frm1.Show()
    End Sub
    Private Sub BtnHlpDimGlobale_Click(sender As System.Object, e As System.EventArgs) Handles BtnHlpDimGlobale.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        FichierAide = 11
        frm1.Show()
    End Sub
    Private Sub BtnHlpJoint_Click(sender As System.Object, e As System.EventArgs) Handles BtnHlpJoint.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        FichierAide = 12
        frm1.Show()
    End Sub
    Private Sub BtnHlpBordure_Click(sender As System.Object, e As System.EventArgs) Handles BtnHlpBordure.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        FichierAide = 13
        frm1.Show()
    End Sub

    Private Sub Rbtn_Sans_Joint_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles Rbtn_Sans_Joint.CheckedChanged
        If Rbtn_Sans_Joint.Checked = True Then
            TxtEsp_Joint.Enabled = False
        End If
    End Sub

    Private Sub Rbtn_Avec_Joint_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles Rbtn_Avec_Joint.CheckedChanged
        If Rbtn_Avec_Joint.Checked = True Then
            TxtEsp_Joint.Enabled = True : TxtEsp_Joint.Focus()
        End If
    End Sub
End Class