Imports System.Windows.Forms

Public Class frmSols
    Private i_sol As Integer = 1 'N de la couche de sol


#Region "Gestion des Textbox"

    Private Sub TextK_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextK.Enter
        TextK.SelectionStart = 0
        TextK.SelectionLength = TextK.Text.Length
    End Sub

    Private Sub Textk_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextK.KeyPress
        Call Gestion_Keypress(e, TextK, True)
    End Sub

    Private Sub TextEp_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextEp.Enter
        TextEp.SelectionStart = 0
        TextEp.SelectionLength = TextEp.Text.Length
    End Sub
    Private Sub Textep_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextEp.KeyPress
        Call Gestion_Keypress(e, TextEp, True)
    End Sub

#End Region

    Private Sub frmSols_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        i_sol = 1
        Call Affichage()

    End Sub

    Private Sub Affichage()
        If frmDal.Total_Sol > 0.1 Then
            Nud_Sol.Value = frmDal.Total_Sol
            TextEp.Text = frmDal.H_sol(i_sol).ToString("#0.00")
            TextK.Text = frmDal.Es(i_sol).ToString("#0.00")
            If frmDal.Substratum = True Then ChkbSubstratum.Checked = True Else ChkbSubstratum.Checked = False
        Else
            TextEp.Text = ""
            TextK.Text = ""
            ChkbSubstratum.Checked = True : frmDal.Substratum = True
        End If
        GB1.Text = "Couche de sol n" & i_sol.ToString
    End Sub

    Private Sub lecture_Couche()
        frmDal.H_sol(i_sol) = CDbl(TextEp.Text)
        frmDal.Es(i_sol) = CDbl(TextK.Text)

    End Sub

    Private Sub BtnPlusCouche_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnPlusCouche.Click
        'affectation des diffrentes valeurs
        frmDal.Total_Sol = CInt(Nud_Sol.Value)
        Call lecture_Couche()

        i_sol = i_sol + 1
        If i_sol > frmDal.Total_Sol Then
            Dim msg As String
            msg = "Le nombre de couches de sol est limit  " & CStr(frmDal.Total_Sol)
            MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, Me.Text)
            i_sol = i_sol - 1
            Exit Sub
        End If
        GB1.Text = "Couche de sol n" & i_sol.ToString
        If frmDal.H_sol(i_sol) > 0.001 Then
            Call Affichage()
        Else
            'effacement de l'affichage complet
            TextK.Text = "" : TextEp.Text = ""
        End If
        TextEp.Focus()
    End Sub
    Private Sub BtnMoinsCouche_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnMoinsCouche.Click
        'affectation des diffrentes valeurs
        Call lecture_Couche()
        If i_sol = 1 Then Exit Sub
        i_sol = i_sol - 1
        Call Affichage()
    End Sub

    Private Sub BtnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnOK.Click
        Dim k11 As Integer
        k11 = Len(GB1.Text)
        If IsNumeric(Microsoft.VisualBasic.Right(GB1.Text, 2)) Then
            i_sol = CInt(Microsoft.VisualBasic.Right(GB1.Text, 2))
        Else
            i_sol = CInt(Microsoft.VisualBasic.Right(GB1.Text, 1))
        End If
        frmDal.Total_Sol = CInt(Nud_Sol.Value)
        Call lecture_Couche()
        If ChkbSubstratum.Checked = True Then frmDal.Substratum = True Else frmDal.Substratum = False
        frmDal.Affichage_general = 1
        frmDal.Affichage_Sol = 1
        Me.Close()
    End Sub

    Private Sub BtnAnnuler_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnAnnuler.Click
        'Dim i, j As Integer
        'If ncouche1(1) > 0.1 Then 'pour le cas 'd'annulation avec aucune entre initiale
        '    For i = 1 To Ty
        '        nCouche(Ty) = ncouche1(Ty)
        '        For j = 1 To nCouche(Ty)
        '            k(i, j, 1) = k1(i, j, 1) : k(i, j, 2) = k1(i, j, 2)
        '        Next
        '    Next
        'End If
        Me.Dispose()
        Me.Finalize()
    End Sub

    Private Sub BtnHlpJointDallage_Click(sender As System.Object, e As System.EventArgs) Handles BtnHlpJointDallage.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        FichierAide = 8
        frm1.Show()
    End Sub
End Class
