﻿Imports System.IO
Public Class frmConfig


    Private Sub frmConfig_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        Dim Verif As Boolean = True
        Dim filename, msgData, msgResult, Chantier, Redacteur As String
        Dim BAEL91, Var_T, Grad_T, Arret_Coulage, retrait_Force As Boolean
        Dim dT_abri, Maille, ϕ_σr, vgs, vgb, cg, enr As Double
        Dim i_result, i_data, Joint_Retrait, Fc, Fe, Eys, Choix_Eyb, Type_Acier, NbLit As Integer


        Try
            filename = Directory.GetCurrentDirectory.ToString() & "\cfg_dallage.ini"
            'Affichage des valeurs en cours 
            Call Lecture_Fichier_Config(filename, Chantier, Redacteur, i_result, i_data, msgData, msgResult, retrait_Force, BAEL91, dT_abri, Var_T, Grad_T, Maille, Arret_Coulage, Joint_Retrait, ϕ_σr, _
                                        Fc, Choix_Eyb, vgb, cg, enr, Fe, Eys, vgs, Type_Acier, NbLit, Verif)
            If Verif = False Then Exit Sub
            Call Affichage(Chantier, Redacteur, i_result, i_data, msgData, msgResult, retrait_Force, BAEL91, dT_abri, Var_T, Grad_T, Maille, Arret_Coulage, Joint_Retrait, ϕ_σr, Fc, Choix_Eyb, vgb, _
                           cg, enr, Fe, Eys, vgs, Type_Acier, NbLit)
            frmDal.Affichage_general = 1 : frmDal.Affichage_Config = 1
        Catch ex As Exception
            MessageBox.Show("Erreur lors de la lecture du fichier de configuration: " & ControlChars.CrLf & ex.Message & ControlChars.CrLf & ex.StackTrace, Me.Text, _
                            MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1)
        End Try
    End Sub

    Private Sub BtnSauvegarde_Click(sender As System.Object, e As System.EventArgs) Handles BtnSauvegarde.Click
        Dim Verif As Boolean = True
        Dim filename, msgData, msgResult, Chantier, Redacteur As String
        Dim BAEL91, Var_T, Grad_T, Arret_Coulage, Retrait_Force As Boolean
        Dim dT_abri, Maille, ϕ_σr, vgb, vgs, Cg, enr As Double
        Dim Joint_Retrait, i_result, i_data, Fc, Fe, Choix_Eyb, Eys, Type_Acier, NbLit As Integer

        Try
            filename = Directory.GetCurrentDirectory.ToString() & "\cfg_dallage.ini"
            Call Lecture(Chantier, Redacteur, i_data, i_result, msgData, msgResult, Retrait_Force, BAEL91, dT_abri, Var_T, Grad_T, Maille, Arret_Coulage, Joint_Retrait, ϕ_σr, Fc, Choix_Eyb, vgb, _
                         Cg, enr, Fe, Eys, vgs, Type_Acier, NbLit, Verif)
            If Verif = False Then Exit Sub
            Call Ecriture_fichier_cfgIni(filename, Chantier, Redacteur, i_result, i_data, msgData, msgResult, Retrait_Force, BAEL91, dT_abri, Var_T, Grad_T, Maille, Arret_Coulage, Joint_Retrait, ϕ_σr,
                                  Fc, Choix_Eyb, vgb, Cg, enr, Fe, Eys, vgs, Type_Acier, NbLit)
            Me.Close() 'quitte le formulaire
        Catch ex As Exception
            MessageBox.Show("Erreur lors de la lecture du fichier: " & ControlChars.CrLf & ex.Message & ControlChars.CrLf & ex.StackTrace, Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1)
        End Try
    End Sub
    Private Sub BtnReinit_Click(sender As System.Object, e As System.EventArgs) Handles BtnReinit.Click

        Dim BAEL91, Var_T, Grad_T, Arret_Coulage, retrait_Force As Boolean
        Dim dT_abri, Maille, ϕ_σr, vgb, vgs, Cg, enr As Double
        Dim Joint_Retrait, i_result, i_data, Fc, Fe, Choix_Eyb, Eys, Type_Acier, NbLit As Integer
        Dim msgData, msgResult, Chantier, Redacteur As String

        MessageBox.Show("Attention, vous allez modifier vos préférences !!!!" & ControlChars.CrLf & "Voulez-vous continuer?", "Calculette Métal", MessageBoxButtons.YesNo, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1) ' 
        If CBool(DialogResult.Yes) Then 'reponse = 6
            Call Variables_generales(Chantier, Redacteur, i_data, i_result, msgData, msgResult, retrait_Force, BAEL91, dT_abri, Var_T, Grad_T, Maille, Arret_Coulage, Joint_Retrait, ϕ_σr, _
                                     Fc, Choix_Eyb, vgb, Cg, enr, Fe, Eys, vgs, Type_Acier, NbLit) 'appel au modules contenant les variables par defaut, écrites en dur dans le logiciel, se trouve dans le module General.vb
            i_data = 1 : i_result = 1
            Call Affichage(Chantier, Redacteur, i_result, i_data, msgData, msgResult, retrait_Force, BAEL91, dT_abri, Var_T, Grad_T, Maille, Arret_Coulage, Joint_Retrait, ϕ_σr, _
                           Fc, Choix_Eyb, vgb, Cg, enr, Fe, Eys, vgs, Type_Acier, NbLit)
        End If

    End Sub
    Private Sub Lecture(ByRef Chantier As String, ByRef Redacteur As String, ByRef i_data As Integer, ByRef i_result As Integer, ByRef msgData As String, ByRef msgResult As String, _
                       ByRef Retrait_Force As Boolean, ByRef BAEL91 As Boolean, ByRef dT_abri As Double, ByRef Var_T As Boolean, ByRef Grad_T As Boolean, _
                        ByRef Maille As Double, ByRef Arret_Coulage As Boolean, ByRef Joint_Retrait As Integer, ByRef ϕ_σr As Double, ByRef Fc As Integer, _
                        ByRef Choix_Eyb As Integer, ByRef vgb As Double, ByRef cg As Double, ByRef enr As Double, ByRef Fe As Integer, ByRef Eys As Integer, ByRef vgs As Double, _
                        ByRef Type_Acier As Integer, ByRef NbLit As Integer, ByRef Verif As Boolean)
        'onglet général
        If RbtnDatadefaut.Checked = True Then 'écriture dans le répertoire data se trouvant dans le même répertoire que le logiciel de calcul
            msgData = Directory.GetCurrentDirectory.ToString() & "\data" : i_data = 1
        Else
            msgData = LblData.Text : i_data = 2
        End If
        If RbtnResultDefaut.Checked = True Then 'écriture dans le même répertoire que le logiciel de calcul
            msgResult = Directory.GetCurrentDirectory.ToString() & "\resultat" : i_result = 1
        Else
            msgResult = LblResult.Text : i_result = 2
        End If
        Chantier = TxtChantier.Text
        Redacteur = TxtRedacteur.Text
        Lecteur_Pdf = TxtPdf.Text
        'onglet options calcul
        If gestionderreur(TxtdT) = True Then dT_abri = CDbl(TxtdT.Text) Else Verif = False
        If ChkbVarT.Checked = True Then Var_T = False Else Var_T = True
        If ChkbGradientThermique.Checked = True Then Grad_T = False Else Grad_T = True
        If gestionderreur(TxtRappChargeExploit) = True Then ϕ_σr = CDbl(TxtRappChargeExploit.Text) Else Verif = False
        If ChkbRetrait.Checked = True Then Retrait_Force = True Else Retrait_Force = False
        'Onglet option construction
        If ChkbArret_Coulage.Checked = True Then Arret_Coulage = True Else Arret_Coulage = False
        If RbtnJointScie.Checked = True Then Joint_Retrait = 4
        If RbtnJointProfile.Checked = True Then Joint_Retrait = 5

        'onglet option modélisation
        If RbtnBAEL.Checked = True Then BAEL91 = True Else BAEL91 = False
        If gestionderreur(TxtMaille) = True Then Maille = CDbl(TxtMaille.Text) / 100 Else Verif = False
        'onglet Matériaux
        'béton
        Fc = CInt(TextFc.Text) : vgb = CSng(TextGb.Text) : cg = CDbl(TextCg.Text) / 1000
        If ChkbModuleBetonBAEL.Checked = True Then Choix_Eyb = 1 'suivant formules BAEL
        If ChkbEnrobage.Checked = True Then enr = 0.03 'enrobage 3cm
        'Acier
        Fe = CInt(TextFe.Text) : vgs = CSng(TextGs.Text)
        Eys = CInt(TextEs.Text)
        If ChkbAcier.Checked = True Then Type_Acier = 2 : NbLit = 1

    End Sub
    Private Sub Affichage(ByVal Chantier As String, ByVal Redacteur As String, ByVal i_result As Integer, ByVal i_data As Integer, ByVal msgData As String, ByVal msgResult As String, _
                         ByVal Retrait_Force As Boolean, ByVal BAEL91 As Boolean, ByVal dT_abri As Double, ByVal Var_T As Boolean, ByVal Grad_T As Boolean, _
                          ByVal Maille As Double, ByVal Arret_Coulage As Boolean, ByVal Joint_Retrait As Integer, ByVal ϕ_σr As Double, ByVal Fc As Integer, _
                        ByVal Choix_Eyb As Integer, ByVal vgb As Double, ByVal cg As Double, ByVal enr As Double, ByVal Fe As Integer, ByVal Eys As Integer, ByVal vgs As Double, _
                        ByVal Type_Acier As Integer, ByVal NbLit As Integer)
        'Onglet général
        TxtChantier.Text = Chantier
        TxtRedacteur.Text = Redacteur
        If i_result = 1 Then RbtnResultDefaut.Checked = True Else RbtnResultPerso.Checked = True
        If i_data = 1 Then RbtnDatadefaut.Checked = True Else RbtndataPerso.Checked = True
        LblData.Text = msgData
        LblResult.Text = msgResult
        TxtPdf.Text = Lecteur_Pdf
        'Onglet Option calcul
        TxtdT.Text = dT_abri.ToString("#0.0")
        If Var_T = False Then ChkbVarT.Checked = True Else ChkbVarT.Checked = False
        If Grad_T = False Then ChkbGradientThermique.Checked = True Else ChkbGradientThermique.Checked = False
        TxtRappChargeExploit.Text = ϕ_σr.ToString("#0.00")
        If Retrait_Force = True Then ChkbRetrait.Checked = True Else ChkbRetrait.Checked = False
        'onglet construction
        If Arret_Coulage = True Then ChkbArret_Coulage.Checked = True Else ChkbArret_Coulage.Checked = False
        Select Case Joint_Retrait
            Case 4
                RbtnJointScie.Checked = True
            Case 5
                RbtnJointProfile.Checked = True
            Case Else
                RbtnJointScie.Checked = False : RbtnJointProfile.Checked = False
        End Select
        'onglet modélisation
        If BAEL91 = True Then RbtnBAEL.Checked = True Else RbtnEurocode.Checked = True
        TxtMaille.Text = (Maille * 100).ToString("#0")
        'Onglet Matériaux
        'béton
        TextFc.Text = Fc.ToString("#0") : TextGb.Text = vgb.ToString("#0.00") : TextCg.Text = (cg * 1000).ToString("#0")
        If Choix_Eyb = 1 Then ChkbModuleBetonBAEL.Checked = True Else ChkbModuleBetonBAEL.Checked = False 'suivant formules BAEL
        If enr = 0.03 Then ChkbEnrobage.Checked = True Else ChkbEnrobage.Checked = False 'enrobage 3cm
        'Acier
        TextFe.Text = Fe.ToString("#0") : TextGs.Text = vgs.ToString("#0.00")
        TextEs.Text = Eys.ToString("#0")
        If Type_Acier = 2 Then
            ChkbAcier.Checked = True : NbLit = 1
        Else
            ChkbAcier.Checked = False
        End If
    End Sub
    Private Function gestionderreur(ByVal e As System.Windows.Forms.TextBox) As Boolean
        If e.Text = "" Then
            EP1.SetError(e, "le champ n'a pas été renseigné!!")
            gestionderreur = False
        ElseIf Not IsNumeric(CDbl(e.Text)) Then
            EP1.SetError(e, "le champ n'est pas une valeur numérique !!")
            gestionderreur = False
        Else
            EP1.SetError(e, "") ' Clear the error.
            gestionderreur = True
        End If
    End Function


    Public Sub Ecriture_fichier_cfgIni(ByVal filename As String, ByVal Chantier As String, ByVal Redacteur As String, ByVal i_result As Integer, ByVal i_data As Integer,
                                 ByVal msgData As String, ByVal msgResult As String, ByVal Retrait_Force As Boolean, ByVal BAEL91 As Boolean, ByVal dT_abri As Double, ByVal Var_T As Boolean,
                                  ByVal Grad_T As Boolean, ByVal Maille As Double, ByVal Arret_Coulage As Boolean, ByVal Joint_Retrait As Integer, ByVal ϕ_σr As Double, ByVal Fc As Integer,
                        ByVal Choix_Eyb As Integer, ByVal vgb As Double, ByVal cg As Double, ByVal enr As Double, ByVal Fe As Integer, ByVal Eys As Integer, ByVal vgs As Double,
                        ByVal Type_Acier As Integer, ByVal NbLit As Integer)
        Dim i As Integer
        Dim myStreamWriter As StreamWriter
        Try
            ' Create a StreamWriter using a Shared (static) File class.
            myStreamWriter = File.CreateText(filename)
            myStreamWriter.WriteLine("Fichier des valeurs par défaut logiciel DALLAGE")
            myStreamWriter.WriteLine("formulaire configuration Onglet Général")
            myStreamWriter.WriteLine(Redacteur)
            myStreamWriter.WriteLine(Chantier)
            'répertoire
            myStreamWriter.WriteLine(msgResult)
            myStreamWriter.WriteLine(msgData)
            myStreamWriter.WriteLine(i_result & " " & i_data)
            myStreamWriter.WriteLine("formulaire configuration Onglets option calcul")
            myStreamWriter.WriteLine(dT_abri & " " & Var_T & " " & Grad_T & " " & ϕ_σr & " " & Retrait_Force)
            myStreamWriter.WriteLine("formulaire configuration Onglets option construction")
            myStreamWriter.WriteLine(Arret_Coulage & " " & Joint_Retrait)
            myStreamWriter.WriteLine("formulaire configuration Onglets option modelisation")
            myStreamWriter.WriteLine(BAEL91 & " " & Maille)
            myStreamWriter.WriteLine("formulaire materiaux")
            myStreamWriter.WriteLine(Fc & " " & Choix_Eyb & " " & vgb & " " & cg & " " & enr)
            myStreamWriter.WriteLine(Fe & " " & Eys & " " & vgs & " " & Type_Acier & " " & NbLit)
            myStreamWriter.Flush() ' Obligatoire - Vide le tampon pour être sûr que tout soit écrit dans le fichier

        Catch exc As Exception
            MessageBox.Show("Le fichier n'a pas pu être ouvert ou écrit" & ControlChars.CrLf & "Vérifiez que le nom du fichier et son chemin d'accès soient exact" & ControlChars.CrLf _
                & "Exception: " & exc.Message & ControlChars.CrLf & exc.StackTrace, Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1)
        Finally
            ' Close the object if it has been created.
            If Not myStreamWriter Is Nothing Then myStreamWriter.Close()
        End Try
    End Sub

    Private Sub BtnResultModif_Click(sender As System.Object, e As System.EventArgs) Handles BtnResultModif.Click
        Try
            With FolderBrowserDialog1
                'En principe, après avoir créé un FolderBrowserDialog, vous définissez RootFolder à l'emplacement à partir duquel commencer la navigation. 
                'Vous pouvez choisir un emplacement dans la liste des dossiers système spéciaux, notamment Program Files, Programmes, System ou Démarrage, qui contiennent des informations communes.  
                .RootFolder = Environment.SpecialFolder.Personal
                ' Si vous le voulez, vous pouvez aussi définir la propriété Description afin de fournir des instructions supplémentaires à l'utilisateur.
                .Description = "Selectionnez le répertoire ..."
                ' Vous pouvez utiliser la propriété ShowNewFolderButton pour déterminer si l'utilisateur est en mesure de créer des dossiers à l'aide du bouton Nouveau dossier.
                .ShowNewFolderButton = True
                If .ShowDialog = Windows.Forms.DialogResult.OK Then
                    LblResult.Text = .SelectedPath
                End If

            End With
        Catch ex As Exception
            MessageBox.Show(ex.Message, Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    Private Sub RbtnResultDefaut_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RbtnResultDefaut.CheckedChanged
        If RbtnResultDefaut.Checked = True Then BtnResultModif.Enabled = False : LblResult.Text = Directory.GetCurrentDirectory.ToString()
    End Sub

    Private Sub RbtnResultPerso_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RbtnResultPerso.CheckedChanged
        If RbtnResultPerso.Checked = True Then BtnResultModif.Enabled = True : BtnResultModif.Focus()
    End Sub

    Private Sub RbtnDatadefaut_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RbtnDatadefaut.CheckedChanged
        If RbtnDatadefaut.Checked = True Then BtnDataModif.Enabled = False : LblData.Text = Directory.GetCurrentDirectory.ToString()
    End Sub

    Private Sub RbtndataPerso_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RbtndataPerso.CheckedChanged
        If RbtndataPerso.Checked = True Then BtnDataModif.Enabled = True : BtnDataModif.Focus()
    End Sub

    Private Sub BtnDataModif_Click(sender As System.Object, e As System.EventArgs) Handles BtnDataModif.Click
        Try
            With FolderBrowserDialog1
                .RootFolder = Environment.SpecialFolder.Personal
                .Description = "Selectionnez le répertoire ..."
                .ShowNewFolderButton = True
                If .ShowDialog = Windows.Forms.DialogResult.OK Then
                    LblData.Text = .SelectedPath
                End If

            End With
        Catch ex As Exception
            MessageBox.Show(ex.Message, Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    Private Sub BtnHlpJointDallage_Click(sender As System.Object, e As System.EventArgs) Handles BtnHlpJointDallage.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        FichierAide = 3
        frm1.Show()
    End Sub

    Private Sub RbtnJointScie_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RbtnJointScie.CheckedChanged
        If RbtnJointScie.Checked = True Then Pb1.Image = My.Resources.Joint_scié '.FromFile(Directory.GetCurrentDirectory.ToString() & "\data\Joint_scié.png")
    End Sub

    Private Sub RbtnJointProfile_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RbtnJointProfile.CheckedChanged
        If RbtnJointProfile.Checked = True Then Pb1.Image = My.Resources.Joint_profilé 'Image.FromFile(Directory.GetCurrentDirectory.ToString() & "\data\Joint_profilé.png")
    End Sub

    Private Sub BtnOK_Click(sender As System.Object, e As System.EventArgs) Handles BtnOK.Click
        Dim Verif As Boolean = True
        Dim msgData, msgResult, Chantier, Redacteur As String
        Dim BAEL91, Var_T, Grad_T, Arret_Coulage, retrait_Force As Boolean
        Dim dT_abri, Maille, ϕ_σr, vgb, vgs, Cg, enr As Double
        Dim Joint_Retrait, i_result, i_data, Fc, Fe, Choix_Eyb, Eys, Type_Acier, NbLit As Integer

        Try
            Call Lecture(Chantier, Redacteur, i_data, i_result, msgData, msgResult, retrait_Force, BAEL91, dT_abri, Var_T, Grad_T, Maille, Arret_Coulage, Joint_Retrait, ϕ_σr, Fc, Choix_Eyb, vgb, _
                         Cg, enr, Fe, Eys, vgs, Type_Acier, NbLit, Verif)
            If Verif = False Then Exit Sub
           
            Me.Close() 'quitte le formulaire
        Catch ex As Exception
            MessageBox.Show("Erreur lors de la lecture du fichier: " & ControlChars.CrLf & ex.Message & ControlChars.CrLf & ex.StackTrace, Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1)
        End Try
    End Sub

    Private Sub BtnAnnuler_Click(sender As System.Object, e As System.EventArgs) Handles BtnAnnuler.Click
        Me.Dispose()
        Me.Finalize()
    End Sub
End Class